CREATE TABLE JCR_CONTAINER(
  VERSION VARCHAR(96) NOT NULL
);
ALTER TABLE JCR_CONTAINER ADD CONSTRAINT JCR_PK_CONTAINER PRIMARY KEY(VERSION);
CREATE TABLE JCR_MITEM(
    ID VARCHAR(96) NOT NULL,
    VERSION INTEGER NOT NULL,
    PATH VARCHAR(4096) NOT NULL
);
ALTER TABLE JCR_MITEM ADD CONSTRAINT JCR_PK_MITEM PRIMARY KEY(ID);
ALTER TABLE JCR_MITEM ADD CONSTRAINT JCR_CU_MITEM_ID UNIQUE (ID, PATH, VERSION);
ALTER TABLE JCR_MITEM ADD CONSTRAINT JCR_CU_MITEM_PATH UNIQUE (PATH, ID, VERSION);
CREATE TABLE JCR_MNODE(
    ID VARCHAR(96) NOT NULL,
    ORDER_NUM INTEGER,
    PARENT_ID VARCHAR(96)
);
ALTER TABLE JCR_MNODE ADD CONSTRAINT JCR_PK_MNODE PRIMARY KEY(ID);
ALTER TABLE JCR_MNODE ADD CONSTRAINT JCR_FK_MNODE_PARENT FOREIGN KEY(PARENT_ID) REFERENCES JCR_MNODE(ID);
ALTER TABLE JCR_MNODE ADD CONSTRAINT JCR_FK_MNODE_ITEM FOREIGN KEY(ID) REFERENCES JCR_MITEM(ID);
ALTER TABLE JCR_MNODE ADD CONSTRAINT JCR_CU_MNODE_PARENT UNIQUE (ID, PARENT_ID, ORDER_NUM);
ALTER TABLE JCR_MNODE ADD CONSTRAINT JCR_CU_MNODE_PARENTID UNIQUE (PARENT_ID, ID, ORDER_NUM);

CREATE TABLE JCR_MPROPERTY(
    ID VARCHAR(96) NOT NULL,
    TYPE INTEGER NOT NULL,
    PARENT_ID VARCHAR(96) NOT NULL,
    MULTIVALUED BOOLEAN NOT NULL
);
ALTER TABLE JCR_MPROPERTY ADD CONSTRAINT JCR_PK_MPROPERTY PRIMARY KEY(ID);
ALTER TABLE JCR_MPROPERTY ADD CONSTRAINT JCR_FK_MPROPERTY_NODE FOREIGN KEY(PARENT_ID) REFERENCES JCR_MNODE(ID);
ALTER TABLE JCR_MPROPERTY ADD CONSTRAINT JCR_FK_MPROPERTY_ITEM FOREIGN KEY(ID) REFERENCES JCR_MITEM(ID);
ALTER TABLE JCR_MPROPERTY ADD CONSTRAINT JCR_CU_MPROPERTY_PARENT UNIQUE (ID, PARENT_ID);
ALTER TABLE JCR_MPROPERTY ADD CONSTRAINT JCR_CU_MPROPERTY_PARENTID UNIQUE (PARENT_ID, ID);
CREATE TABLE JCR_MVALUE(
    ID BIGSERIAL NOT NULL, 
	DATA BYTEA NOT NULL,
    ORDER_NUM INTEGER,
    PROPERTY_ID VARCHAR(96) NOT NULL
);
ALTER TABLE JCR_MVALUE ADD CONSTRAINT JCR_PK_MVALUE PRIMARY KEY(ID);
ALTER TABLE JCR_MVALUE ADD CONSTRAINT JCR_FK_MVALUE_PROPERTY FOREIGN KEY(PROPERTY_ID) REFERENCES JCR_MPROPERTY(ID);
ALTER TABLE JCR_MVALUE ADD CONSTRAINT JCR_CU_MVALUE_PROPERTY UNIQUE (PROPERTY_ID, ORDER_NUM);
CREATE TABLE JCR_MREF(
  NODE_ID VARCHAR(96) NOT NULL,
  PROPERTY_ID VARCHAR(96) NOT NULL,
  ORDER_NUM INTEGER NOT NULL
);
ALTER TABLE JCR_MREF ADD CONSTRAINT JCR_PK_MREF PRIMARY KEY(NODE_ID, PROPERTY_ID, ORDER_NUM);
ALTER TABLE JCR_MREF ADD CONSTRAINT JCR_CU_MREF_PROPERTY UNIQUE (PROPERTY_ID, ORDER_NUM);